# Pelion Device Management SDK for JavaScript

[![License](https://img.shields.io/badge/License-Apache%202.0-blue.svg)](https://spdx.org/licenses/Apache-2.0.html)
[![version](https://img.shields.io/npm/v/mbed-cloud-sdk.svg)](https://www.npmjs.com/package/mbed-cloud-sdk)
[![CircleCI](https://circleci.com/gh/ARMmbed/mbed-cloud-sdk-javascript/tree/master.svg?style=svg)](https://circleci.com/gh/ARMmbed/mbed-cloud-sdk-javascript/tree/master)
[![codecov](https://codecov.io/gh/ARMmbed/mbed-cloud-sdk-javascript/branch/master/graph/badge.svg?token=9h7ZMJ0xwK)](https://codecov.io/gh/ARMmbed/mbed-cloud-sdk-javascript)
[![engine](https://img.shields.io/node/v/mbed-cloud-sdk.svg)](https://nodejs.org/en/about/releases/)
[![downloads](https://img.shields.io/npm/dm/mbed-cloud-sdk.svg)](https://www.npmjs.com/package/mbed-cloud-sdk)

The Pelion Device Management SDK provides a simplified interface to the Pelion Device Management APIs by exposing functionality using conventions and paradigms familiar to JavaScript developers.

## Prerequisites

[Node.js > v10.16.0 (lts)](https://nodejs.org)
[yarn](https://yarnpkg.com/)

## Installation

The SDK is distributed using npm. To install the package in your project:

```bash
$ yarn add mbed-cloud-sdk
```

`/node_modules/mbed-cloud-sdk` now contains:

* `bundles` - minified browser scripts.
* `lib` - CommonJS modules.
* `lib-es6` - ESNext modules.
* `types` - Typescript types.

## Documentation and examples

See the full documentation and API reference at [https://cloud.mbed.com/docs/latest/mbed-cloud-sdk-javascript](https://cloud.mbed.com/docs/latest/mbed-cloud-sdk-javascript).

Please refer to the examples folder for some node and web examples.

## Contributing

Pelion Device Management SDK for JavaScript is open source and we would like your help; there is a
brief guide on how to get started in [CONTRIBUTING.md](CONTRIBUTING.md).

## License

Pelion Device Management SDK for JavaScript is free-to-use and licensed under the **Apache License
2.0**. See [LICENSE](LICENSE) file for more information.
