"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var __values = (this && this.__values) || function(o) {
    var s = typeof Symbol === "function" && Symbol.iterator, m = s && o[s], i = 0;
    if (m) return m.call(o);
    if (o && typeof o.length === "number") return {
        next: function () {
            if (o && i >= o.length) o = void 0;
            return { value: o && o[i++], done: !o };
        }
    };
    throw new TypeError(s ? "Object is not iterable." : "Symbol.iterator is not defined.");
};
Object.defineProperty(exports, "__esModule", { value: true });
/*
 * Pelion Device Management JavaScript SDK
 * Copyright Arm Limited 2017
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
var utils_1 = require("../../../common/utils");
var functions_1 = require("../../../legacy/common/functions");
var types_1 = require("../../../legacy/connect/types");
var observer_1 = require("./observer");
var ResourceValuesObserver = /** @class */ (function (_super) {
    __extends(ResourceValuesObserver, _super);
    function ResourceValuesObserver(_filter, _connect, firstValue) {
        if (firstValue === void 0) { firstValue = "OnValueUpdate"; }
        var _this = _super.call(this) || this;
        _this.firstValue = firstValue;
        _this.localPresubscriptions = new Array();
        if (_connect) {
            _this.connect = _connect;
        }
        if (_filter) {
            _this.filter = _filter;
            // create presubscriptions
            functions_1.ensureArray(_this.filter.deviceId).forEach(function (d) {
                _this.localPresubscriptions.push({
                    deviceId: d,
                    resourcePaths: _this.filter.resourcePaths || new Array(),
                });
            });
        }
        return _this;
    }
    /**
     * Notify this observer
     * @param data
     */
    ResourceValuesObserver.prototype.notify = function (data) {
        if (this.subscribed) {
            if (this.localPresubscriptions.length === 0) {
                _super.prototype.notify.call(this, data);
            }
            if (this.compareData(data)) {
                _super.prototype.notify.call(this, data);
            }
        }
    };
    /**
     * Stop this observer from recieving notifications
     */
    ResourceValuesObserver.prototype.unsubscribe = function () {
        this.subscribed = false;
        _super.prototype.clearListeners.call(this);
    };
    ResourceValuesObserver.prototype.compareData = function (data) {
        return this.localPresubscriptions.some(function (sub) {
            return (functions_1.matchWithWildcard(sub.deviceId, data.deviceId) &&
                (sub.resourcePaths.length === 0 || sub.resourcePaths.some(function (r) { return functions_1.matchWithWildcard(r, data.path); })));
        });
    };
    ResourceValuesObserver.prototype.syncPresubscriptions = function () {
        var _a, _b, _c, _d, _e, _f, _g, _h, _j, _k;
        return __awaiter(this, void 0, void 0, function () {
            var serverPresubscriptions, connectedDevices, _loop_1, this_1, _l, _m, p, e_1_1;
            var e_1, _o;
            return __generator(this, function (_p) {
                switch (_p.label) {
                    case 0:
                        (_b = (_a = this.connect) === null || _a === void 0 ? void 0 : _a._log) === null || _b === void 0 ? void 0 : _b.debug("syncing subscriptions...");
                        return [4 /*yield*/, ((_c = this.connect) === null || _c === void 0 ? void 0 : _c.listPresubscriptions())];
                    case 1:
                        serverPresubscriptions = _p.sent();
                        return [4 /*yield*/, ((_d = this.connect) === null || _d === void 0 ? void 0 : _d.updatePresubscriptions(this.unionOfPresubscriptions(serverPresubscriptions, this.localPresubscriptions)))];
                    case 2:
                        _p.sent();
                        if (!(this.firstValue === "OnValueUpdate")) return [3 /*break*/, 11];
                        return [4 /*yield*/, ((_e = this.connect) === null || _e === void 0 ? void 0 : _e.listConnectedDevices())];
                    case 3:
                        connectedDevices = (_f = (_p.sent())) === null || _f === void 0 ? void 0 : _f.data;
                        _loop_1 = function (p) {
                            var matchingDevices, matchingDevices_1, matchingDevices_1_1, m, resources, _loop_2, resources_1, resources_1_1, q, e_2_1, e_3_1;
                            var e_3, _a, e_2, _b;
                            return __generator(this, function (_c) {
                                switch (_c.label) {
                                    case 0:
                                        matchingDevices = (_g = connectedDevices === null || connectedDevices === void 0 ? void 0 : connectedDevices.filter(function (device) { return functions_1.matchWithWildcard(device.id, p.deviceId); })) !== null && _g !== void 0 ? _g : [];
                                        _c.label = 1;
                                    case 1:
                                        _c.trys.push([1, 13, 14, 15]);
                                        matchingDevices_1 = (e_3 = void 0, __values(matchingDevices)), matchingDevices_1_1 = matchingDevices_1.next();
                                        _c.label = 2;
                                    case 2:
                                        if (!!matchingDevices_1_1.done) return [3 /*break*/, 12];
                                        m = matchingDevices_1_1.value;
                                        return [4 /*yield*/, m.listResources()];
                                    case 3:
                                        resources = _c.sent();
                                        _loop_2 = function (q) {
                                            var e_4;
                                            return __generator(this, function (_a) {
                                                switch (_a.label) {
                                                    case 0:
                                                        if (!(p.resourcePaths.length === 0 || p.resourcePaths.some(function (w) { return functions_1.matchWithWildcard(w, q.path); }))) return [3 /*break*/, 4];
                                                        if (!q.observable) return [3 /*break*/, 4];
                                                        _a.label = 1;
                                                    case 1:
                                                        _a.trys.push([1, 3, , 4]);
                                                        return [4 /*yield*/, ((_h = this_1.connect) === null || _h === void 0 ? void 0 : _h.addResourceSubscription(m.id, q.path))];
                                                    case 2:
                                                        _a.sent();
                                                        return [3 /*break*/, 4];
                                                    case 3:
                                                        e_4 = _a.sent();
                                                        (_k = (_j = this_1.connect) === null || _j === void 0 ? void 0 : _j._log) === null || _k === void 0 ? void 0 : _k.error("failed to create subscription for " + m.id + " " + q.path);
                                                        return [3 /*break*/, 4];
                                                    case 4: return [2 /*return*/];
                                                }
                                            });
                                        };
                                        _c.label = 4;
                                    case 4:
                                        _c.trys.push([4, 9, 10, 11]);
                                        resources_1 = (e_2 = void 0, __values(resources)), resources_1_1 = resources_1.next();
                                        _c.label = 5;
                                    case 5:
                                        if (!!resources_1_1.done) return [3 /*break*/, 8];
                                        q = resources_1_1.value;
                                        return [5 /*yield**/, _loop_2(q)];
                                    case 6:
                                        _c.sent();
                                        _c.label = 7;
                                    case 7:
                                        resources_1_1 = resources_1.next();
                                        return [3 /*break*/, 5];
                                    case 8: return [3 /*break*/, 11];
                                    case 9:
                                        e_2_1 = _c.sent();
                                        e_2 = { error: e_2_1 };
                                        return [3 /*break*/, 11];
                                    case 10:
                                        try {
                                            if (resources_1_1 && !resources_1_1.done && (_b = resources_1.return)) _b.call(resources_1);
                                        }
                                        finally { if (e_2) throw e_2.error; }
                                        return [7 /*endfinally*/];
                                    case 11:
                                        matchingDevices_1_1 = matchingDevices_1.next();
                                        return [3 /*break*/, 2];
                                    case 12: return [3 /*break*/, 15];
                                    case 13:
                                        e_3_1 = _c.sent();
                                        e_3 = { error: e_3_1 };
                                        return [3 /*break*/, 15];
                                    case 14:
                                        try {
                                            if (matchingDevices_1_1 && !matchingDevices_1_1.done && (_a = matchingDevices_1.return)) _a.call(matchingDevices_1);
                                        }
                                        finally { if (e_3) throw e_3.error; }
                                        return [7 /*endfinally*/];
                                    case 15: return [2 /*return*/];
                                }
                            });
                        };
                        this_1 = this;
                        _p.label = 4;
                    case 4:
                        _p.trys.push([4, 9, 10, 11]);
                        _l = __values(this.localPresubscriptions), _m = _l.next();
                        _p.label = 5;
                    case 5:
                        if (!!_m.done) return [3 /*break*/, 8];
                        p = _m.value;
                        return [5 /*yield**/, _loop_1(p)];
                    case 6:
                        _p.sent();
                        _p.label = 7;
                    case 7:
                        _m = _l.next();
                        return [3 /*break*/, 5];
                    case 8: return [3 /*break*/, 11];
                    case 9:
                        e_1_1 = _p.sent();
                        e_1 = { error: e_1_1 };
                        return [3 /*break*/, 11];
                    case 10:
                        try {
                            if (_m && !_m.done && (_o = _l.return)) _o.call(_l);
                        }
                        finally { if (e_1) throw e_1.error; }
                        return [7 /*endfinally*/];
                    case 11: return [2 /*return*/];
                }
            });
        });
    };
    ResourceValuesObserver.prototype.unionOfPresubscriptions = function (server, local) {
        return utils_1.union(server, local, types_1.presubscriptionsEqual);
    };
    return ResourceValuesObserver;
}(observer_1.Observer));
exports.ResourceValuesObserver = ResourceValuesObserver;
//# sourceMappingURL=resourceValuesObserver.js.map