import { Entity } from "../../../common/entity";
import { LoginProfileType } from "./types";
/**
 *LoginProfile
 */
export interface LoginProfile extends Entity {
    /**
     *The ID of the user in the identity provider's service.
     *@example fed/user_007
     */
    readonly foreignId?: string;
    /**
     *Identity provider type.
     *@example NATIVE
     */
    readonly loginProfileType?: LoginProfileType;
    /**
     *Name of the identity provider.
     *@example Pelion
     */
    name?: string;
}
