import { Repository } from "../../../common/repository";
import { CertificateIssuer } from "./certificateIssuer";
import { CertificateIssuerCreateRequest } from "./types";
import { CertificateIssuerUpdateRequest } from "./types";
import { VerificationResponse } from "../../index";
import { Paginator } from "../../../index";
import { ListOptions } from "../../../common";
/**
 *CertificateIssuer repository
 */
export declare class CertificateIssuerRepository extends Repository {
    /**
     * create
     * @param request - The entity to perform action on.
     */
    create(request: CertificateIssuerCreateRequest): Promise<CertificateIssuer>;
    /**
* delete
* @param id - Certificate issuer ID.
An active certificate issuer cannot be deleted.
*/
    delete(id: string): Promise<void>;
    /**
     * list
     * @param options - options
     */
    list(options?: ListOptions): Paginator<CertificateIssuer, ListOptions>;
    /**
     * read
     * @param id - Certificate issuer ID.
     */
    read(id: string): Promise<CertificateIssuer>;
    /**
     * update
     * @param request - The entity to perform action on.
     * @param id - Certificate issuer ID.
     */
    update(request: CertificateIssuerUpdateRequest, id: string): Promise<CertificateIssuer>;
    /**
     * verify
     * @param id - Certificate issuer ID.
     */
    verify(id: string): Promise<VerificationResponse>;
}
